(in-package "PENMAN")

(defspl-macro :pre-determiner
	      ((total-es
		 :pre-deicticity-q predeicticity)

		
		)
)

(defspl-macro :post-determiner
	      ((alternative-es
		 :post-deictic-q postdeicticity)

		
		)
)

(defspl-macro :possessive-relative
	      ((?
		:possessive-elaboration-q +possessive
		:question-item-id ? 
		))
)

(defspl-macro :impersonal
	      ((generic-plural
	  		:impersonality-q impersonal
	  		:impersonality-type-q they
		)
		(se
	  		:impersonality-q impersonal
			:impersonality-type-q se
		)
		(one
 		:impersonality-q impersonal
		:impersonality-type-q one
		)

		)
)


(defspl-macro :voice
	      ((passive
	  :voice-q nonactive
		)
		(active
	  :voice-q active
		)
		(reflexive-passive
	  :voice-q nonactive
	  :passive-type-q reflexive
		)
		(passive-reflexive
	  :voice-q nonactive
	  :passive-type-q reflexive
		))
)

(defspl-macro :owned-by
	      ((?
	  :current-representative-id determiner
		:identifiability-q identifiable
		:proximity-modification-q noproximity
		:possessor-modification-q possessor
		:owner-id ?
		))
)

(defspl-macro :quantity
	      ((?
			:quantity-cc-q +quantity
			:quantity-cc-id ?
		))
)

(defspl-macro :2nd-temporal-locating
	      ((?
			:2nd-temporal-location-specification-q temporallocation
			:2nd-temporal-location-id ?
		))
)

(defspl-macro :modality
	      ((ability
		 :modalisation-Q modalised
          	 :modality-TYPE-Q agent-oriented
		 :agent-oriented-type-q ability)
	       
	       
		(obligation
		 :modalisation-Q modalised
          	 :modality-TYPE-Q agent-oriented
		:agent-oriented-type-q obligation)
	       
		(possibility
		 :modalisation-Q modalised
          	 :modality-TYPE-Q epistemic
		:epistemic-type-q possibility)
	
		(probability
		 :modalisation-Q modalised
          	 :modality-TYPE-Q epistemic
		:epistemic-type-q probability)

		(inferred_certainty
		 :modalisation-Q modalised
          	 :modality-TYPE-Q epistemic
		:epistemic-type-q inferred_certainty)

		(counter-factual
		 :modalisation-Q modalised
          	 :modality-TYPE-Q epistemic
		:epistemic-type-q counter-factual)

		(optative
		 :modalisation-Q modalised
          	 :modality-TYPE-Q speaker-oriented
		:speaker-oriented-type-q optative)
		
		(permissive
		 :modalisation-Q modalised
          	 :modality-TYPE-Q speaker-oriented
		:speaker-oriented-type-q permissive)

		(admonitive
		 :modalisation-Q modalised
          	 :modality-TYPE-Q speaker-oriented
		:speaker-oriented-type-q admonitive)

		(root_possibility
		 :modalisation-Q modalised
          	 :modality-TYPE-Q agent-oriented
		:agent-oriented-type-q root_possibility)

		(intention
		 :modalisation-Q modalised
          	 :modality-TYPE-Q agent-oriented
		:agent-oriented-type-q intention)
	       ))

(defspl-macro :frequency
	      ((?
			:frequency-q +frequency
			:frequency-id ?
		))
)

(defspl-macro :phase
	      ((?
			:phase-cc-q +phase
			:phase-cc-id ?
		))
)
		 


(defspl-macro :determiner
	      ((indefinite-es
		  :identifiability-q notidentifiable
		 :current-representative-id determiner
		:deictic-quantity-q lowquantity
		:identicality-comparison-modification-q nocomparison)

		(indefinite-selective-es ;some/algunos
		 :current-representative-id determiner
		:amount-attention-q nonminimalattention
		:presuppose-existence-q presupposed)

		(indefinite-cualquier-es
		:current-representative-id determiner
		:amount-attention-q nonminimalattention
		:presuppose-existence-q notpresupposed)

		(dual-es
      	 	:current-representative-id determiner
		:set-totality-q total
		:duality-q dual
		)

	       (total-es
		:current-representative-id determiner
		:identifiability-q notidentifiable
		:set-totality-q total
		:duality-q nondual
		)
	       (negative-es
		 :current-representative-id determiner
		:set-totality-q total
		:set-totality-polarity-q negative)
	       (definite-es
		 :current-representative-id determiner
		:identifiability-q identifiable
		:amount-attention-q nonminimalattention)
	       (far-demonstrative-es
		 :identifiability-q identifiable
		:proximity-modification-q proximity
		:proximity-mod-id (speaker / person
					    :distance-q far))
	       (near-demonstrative-es
		 :identifiability-q identifiable
		:proximity-modification-q proximity
		:proximity-mod-id (speaker / person
					    :distance-q near))
		 (remote-demonstrative-es
		 :identifiability-q identifiable
		:proximity-modification-q proximity
		:proximity-mod-id (speaker / person
					    :distance-q remote))
	       (zero-es
		 :identifiability-q notidentifiable
		 :current-representative-id ?s1
		 :potential-representative-id ?s2
		 :set-totality-q (?s1 ?s2) partial
		 :singularity-q nonsingular
		 :deictic-quantity-q noquantity
		 :amount-attention-q minimalattention)
)
)
(defspl-macro :indefinite-quantity
	      ((interrogative-es
		 :EMPTY-NUMBER-Q NONEMPTY
		:quantity-q quantity
		:quantification-id quantity)
		(high-es
		 :quantification-q nonquantified
		:quantification-qq quantified
		:quantification-id numerative
		:number-relativity-q relative
		:high-quantity-q high)
	       
	       (low-es
		 :quantification-q nonquantified
		:quantification-qq quantified
		:quantification-id numerative 
		:number-relativity-q relative
		:high-quantity-q nonhigh
		:low-quantity-q low)

	       (more-es
		 :quantification-q nonquantified
		:quantification-qq quantified
		:quantification-id numerative
		:comparative-quantity-q comparativequantity)
	       (less-es
		 :quantification-q nonquantified
		:quantification-qq quantified
		:quantification-id numerative
		:comparative-quantity-q comparativequantity
		:quantity-exceed-q nonexceed)
		(as-es
		 :quantification-q nonquantified
		:quantification-qq quantified
		:quantification-id numerative
		:comparative-quantity-q comparativequantity
		:quantity-exceed-q nonexceed
		:quantity-not-exceed-q equal)
		(excessive-es
		  :quantification-q nonquantified
		:quantification-qq quantified
		:quantification-id numerative
		:comparative-quantity-q comparativequantity
		:quantity-threshold-value-q thresholdvalue)
	       (sufficient-es
		  :quantification-q nonquantified
		:quantification-qq quantified
		:quantification-id numerative
		:comparative-quantity-q comparativequantity
		:quantity-threshold-value-q thresholdvalue
		:judgement-on-quantity-q sufficient)
))


(defspl-macro :number
	      ((plural
		 :multiplicity-q multiple
		 :singularity-q nonsingular)
	       (singular
		 :multiplicity-q unitary
		 :singularity-q singular)
	       (mass
		 :multiplicity-q unitary
		 :singularity-q nonsingular)))

(defspl-macro :aspect
	      ((progressive
		 :ASPECT-Q ASPECT
          	 :ASPECT-TYPE-Q PROGRESSIVE)
	       (gradual
		 :ASPECT-Q ASPECT
          	 :ASPECT-TYPE-Q gradual)
	       ))



(defspl-macro :name
	      ((?
		 :favor-q classify
		 :identifiability-q identifiable
		 :lex ?)))

(defspl-macro :polarity
	      ((positive
		 :polarity-id (?po / Positive))
		(positive-shared
		 :polarity-id (?po / Positive :shared-q +shared))
	       (negative
		 :polarity-id (?po / Negative))
		(negative-shared
		 :polarity-id (?po / negative :shared-q +shared))
	       (variable
		 :polarity-id (?po / Polarity-Variable))
	       (? :polarity-id ?)))


(defspl-macro :pronoun
	      (
		(noninteractant-es
		:empty-number-q empty
		:identifiability-q identifiable)
		
		(negative-es ;nada/nothing nadie/nobody
		:empty-number-q empty
		:set-totality-q total
		:set-totality-polarity-q negative)

		(total-es ;todo el mundo/everybody todo/everything
		:empty-number-q empty
		:set-totality-q total
		:set-totality-polarity-q positive)

		(indefinite-es ;algo/something alguien/somebody
		:empty-number-q empty
		:set-totality-polarity-q negative)

)
)
(defspl-macro :general-qualification
	      ((? :property-q property
		:attribuend-qualification-q attribuendqualification
		:attribuend-id ?
		)
	      )
)


(defspl-macro :intensified
	      ((morphologically
			:INTENSIFY-ADJECTIVE-Q INTENSIFIED
               		:INTENSIFY-TYPE-ADJECTIVE-Q MORPHOLOGICALLY-INTENSIFIED)
	       (?
			:ADJECTIVE-INTENSIFIER
               			(INT / ADVERB
                    		:LEX ? )
			)
	       )
)

(defspl-macro :intensified-adverb
	      ((morphologically
			:INTENSIFY-adverb-Q INTENSIFIED
               		:INTENSIFY-TYPE-adverb-Q MORPHOLOGICALLY-INTENSIFIED)
	       (?
			:ADverb-INTENSIFIER
               			(INT / ADVERB
                    		:LEX ? )
			)
	       )
)


(defspl-macro :scaling
	      ((more   :scalability-q scalable
		       :scaling-q scaled
		       :proper-subset-q proper
		       :exceed-q exceed)
	       (most   :scalability-q scalable
		       :scaling-q scaled
		       :proper-subset-q nonproper
		       :exceed-superlative-q exceed)
	       (least  :scalability-q scalable
		       :scaling-q scaled
		       :proper-subset-q nonproper
		       :exceed-superlative-q nonexceed)
	       (less   :scalability-q scalable 
		       :scaling-q scaled
		       :item-value-id ?item
		       :standard-id ?standard
		       :standard-mention-q withhold
		       :exceed-q (?item ?standard) nonexceed
		       :exceed-q (?standard ?item) exceed)
	       (as     :scalability-q scalable 
		       :scaling-q scaled
		       :exceed-q nonexceed)
		(so	:SCALABILITY-Q SCALABLE
               		:SCALING-Q SCALED
               		:PROPER-SUBSET-Q PROPER
               		:THRESHHOLD-VALUE-Q THRESHHOLDVALUE
               		:MAXIMUM-Q NONMAXIMUM
               		:MARKED-PROPERTY-Q MARKED)
	       (enough :scalability-q scalable 
		       :scaling-q scaled
		       :proper-subset-q proper
		       :threshhold-value-q threshholdvalue
		       :maximum-q nonmaximum)
	       (too    :scalability-q scalable 
		       :scaling-q scaled
		       :proper-subset-q proper
		       :threshhold-value-q threshholdvalue
		       :maximum-q maximum)))

(defspl-macro :speechact
	      ((assertion
		 :speech-act-id (?sa / Assertion
				     :polarity Positive))
	       (denial
		 :speech-act-id (?sa / Assertion
				     :polarity Negative))
	       (yes-no-question
		 :speech-act-id (?sa / Question
				     :polarity variable))
	       (imperative
		 :speech-act-id (?sa / Command
				     :polarity Positive))
	       (yes-answer
		 :speech-act-id (?sa / Answer
				     :polarity Positive
				     :polarity-answer-q polarityanswer))
	       (no-answer
		 :speech-act-id (?sa / Answer
				     :polarity Negative
				     :polarity-answer-q polarityanswer))
	       (when-question
		 :speech-act-id (?sa / Question
				     :polarity positive)
		 :question-item-id id
		 :temporal-location-specification-q temporallocation
		 :temporal-location-id (id / time-interval
					   :question-variable-q variable
					   :location-relation-specificity-q unspecified))
	       (why-question
		 :speech-act-id (?sa / Question
				     :polarity positive)
		 :question-item-id (id / thing
				       :causation-q cause
				       :property-quality-q notproperty)
		 :cause-id (id / thing
			       :question-variable-q variable)
		 )
	       (how-question
		 :speech-act-id (?sa / Question
				    :polarity positive)
		 :question-item-id (id / thing
				       :circumstance-q circumstance
				       :attitude-q notattitude
				       :question-variable-q variable
				       :property-quality-q property))
    
	       (? :speech-act-id ?)))

(defspl-macro :adjective-intensifier
	      ((? :intensify-adjective-q intensified
		  :intensify-type-adjective-q syntactically-intensified
                  :intensifier-id ?)))

(defspl-macro :adverb-intensifier
	      ((? :intensify-adverb-q intensified
		  :intensify-type-adverb-q syntactically-intensified
                  :adverb-intensifier-id ?)))

(defspl-macro :comparison-modification
	      ((? :comparison-modification-q modification
                  :modifier-id (adverb / adverb :lex ?))))

(defspl-macro :standard-as
	      ((? :scaling as
		  :standard-id ?)))

(defspl-macro :standard-enough
	      ((? :scaling enough
		  :standard-id ?)))

(defspl-macro :standard-less
	      ((? :scalability-q scalable
		  :scaling-q scaled
		  :item-value-id ?item
		  :standard-id ?
		  :exceed-q (?item ?) nonexceed
		  :exceed-q (? ?item) exceed
		  :standard-mention-q mention
		  :standard-id ?)))

(defspl-macro :standard-more
	      ((? :scaling more
		  :standard-id ?)))

(defspl-macro :standard-most
	      ((? :scaling most
		  :standard-id ?)))

(defspl-macro :standard-least
	      ((? :scaling least
		  :standard-id ?)))

(defspl-macro :standard-too
	      ((? :scaling too
		  :standard-id ?)))

(defspl-macro :substitution
	      ((adj-ellipsis
		 :property-q property
                 :minimal-attention-q minimal
		 )
	       (ellipsis
		 :minimal-attention-q minimal
		 :semantic-coverage-q covered)))

(defspl-macro :tense
	      ((present
		 :absolute-temporal-location-q simul)
		(past
		 :absolute-temporal-location-q before
		 :relative-tense-q norelative)
		(future
		 :absolute-temporal-location-q after)
		(present-in-present
		 :absolute-temporal-location-q simul
		:relative-tense-q relative
		:relative-temporal-location-q simul)
		(present-in-past
		 :absolute-temporal-location-q before
		:relative-tense-q relative
		:relative-temporal-location-q simul)
		(past-in-present
		 :absolute-temporal-location-q simul
		:relative-tense-q relative
		:relative-temporal-location-q before)
		(past-in-past
		 :absolute-temporal-location-q before
		:relative-tense-q relative
		:relative-temporal-location-q before)
		(past-in-future
		 :absolute-temporal-location-q after
		:relative-tense-q relative
		:relative-temporal-location-q before)
		(future-in-past
		 :absolute-temporal-location-q before
		:relative-tense-q relative
		:relative-temporal-location-q after)
		(future-in-present
		 :absolute-temporal-location-q simul
		:relative-tense-q relative
		:relative-temporal-location-q after)
		)
)
		

(defspl-macro :what-question   ;;; Unfortunately, not possible as a :SPEECHACT macro:
	                       ;;; Requires coordination of :question-item-id with 
	                       ;;; arbitrary roles from the body of the SPL.  See PRIMER-51B & PRIMER-52B.
	      ((?
		 :speech-act-id (q / Question
				   :polarity positive)
		 :question-item-id ?)))


(defspl-macro :conjunctive
              ((additive
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q joint
                 :contrastive-q notcontrastive
                 :similarity-q notsimilarity
                 :correction-q notcorrection
                 :disjunctive-q notdisjunctive
               ;  :concessive-q nonconcessive
			)      
               (alternatively
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q joint
                 :contrastive-q contrastive)
               (before
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q notsequence
                 :presentation-q notpresentational
                 :time-relation-q timerelation
                 :time-precedence-q precedence
                 :time-precede-q notsubsequent
                 :time-separation-q immediate)
               (besides
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q joint
                 :contrastive-q notcontrastive
                 :similarity-q notsimilarity
                 :correction-q correction)
               (further
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q sequence
                 :absolute-position-q notabsolute
                 :relative-position-q immediate)
               (generally
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q notjoint
                 :presentational-relation-q presentational
                 :reexpression-q notreexpression
                 :abstraction-q abstraction
                 :generalization-direction-q generalization)
               (however
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q notjoint
                 :presentational-relation-q notpresentational
                 :hypothesis-opposition-q hypothesisopposition)
               (immediately
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q notsequence
                 :presentation-q notpresentational
                 :time-relation-q timerelation
                 :time-precedence-q precedence
                 :time-precede-q subsequent
                 :time-separation-q immediate)
               (in-fact
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q notjoint
                 :presentational-relation-q presentational
                 :reexpression-q reexpression)
               (in-particular
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q notjoint
                 :presentational-relation-q presentational
                 :reexpression-q notreexpression
                 :abstraction-q abstraction
                 :generalization-direction-q example)
               (joint-however
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q joint
                 :contrastive-q notcontrastive
                 :similarity-q notsimilarity
                 :correction-q notcorrection
                 :disjunctive-q disjunctive)
               (previously
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q notsequence
                 :presentation-q notpresentational
                 :time-relation-q timerelation
                 :time-precedence-q precedence
                 :time-precede-q notsubsequent
                 :time-separation-q separate
                 :small-separation-q small
                 :tense past)
               (secondly
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q sequence
                 :absolute-position-q absolute
                 :extremal-position-q notextremal)
               (similarly
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q joint
                 :contrastive-q notcontrastive
                 :similarity-q similarity)
               (simultaneously
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q notsequence
                 :presentation-q notpresentational
                 :time-relation-q timerelation
                 :time-precedence-q noprecedence)
               (spatial-besides
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q notsequence
                 :presentation notpresentational
                 :time-relation-q nottimerelation
                 :spatial-relation-q spacerelation)
               (still                                 ;; this filler added
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q notprocessregulated
                 :joint-regard-q joint
                 :contrastive-q notcontrastive
                 :similarity-q notsimilarity
                 :correction-q notcorrection
                 :disjunctive-q notdisjunctive
                 :concessive-q concessive)
               (then
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q notsequence
                 :presentation-q notpresentational
                 :time-relation-q timerelation
                 :time-precedence-q precedence
                 :time-precede-q subsequent
                 :time-separation-q separate
                 :small-separation-q notsmall)
               (therefore
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q necessity)
               (ultimately
                 :conjunctive-relation-q conjunctive
                 :conjunctive-relation-id (?rr / rhetorical-relation)
                 :process-regulated-q processregulated
                 :necessity-q nonecessity
                 :sequence-q sequence
                 :absolute-position-q absolute
                 :extremal-position-q extremal)
               ))

