(in-package "KPML")

;;; File creation information: 
;;; 14-6-2002 17:50:39 at Unknown.




(define-language-morphology-requirements :language :SPANISH
    :systemicized t
 ;   :generator-fn ENGLISH-GRAMMATICAL-FEATURES-TO-LEXICAL-FEATURE
    )

(define-language-standard-defaults
  :language :SPANISH :defaults (BASIC-ASSERTION PRESENT-TENSE))

(define-language-standard-abbreviation
  :language :SPANISH :abbreviation ES)

(define-string-clean-ups
  :language :SPANISH 
  :clean-ups (("," " y  *[*") ("" "*[*") ("." ",.") ("." "  .") ("," "  ,") ("." ".,") ("?" "?.") ("!" "!.") ("?" " ?") ("!" " !") ("," ",,") 

		 
		;euphonic variants of the article
		
		(" el a" " la //")
		(" el ha" " la h//")
		(" el " " la ")
		(" el h" " la h")
		(" el A" " la //")
		(" el Ha" " la H//")
		(" el " " la ")
		(" el H" " la H")
		("a" "//")
		("ha" "h//")
		("" "//")
		("Ha" "H//")

		;prepositions and article contracted. must come after euphonic variants of the article
		(" del " " de  el ") 
		 (" al " " a  el ")

		;euphonic variants of conjuctions
		(" e i" " y i")
		 (" e hi" " y hi")
		 (" u o" " o o")
		 (" u ho" " o ho") 

		;spelling alternations of the conjugation
		(" yendo" " iendo") 
		("yeron " "yieron ") 
		("y " "yi ")
		("ajeron " "ajieron ") 
		("ujeron " "ujieron ") 
		("ijeron " "ijieron ")
		 
		("ge" "/x/e")
		("gi" "/x/i")
		("g" "/x/")
		("g" "/x/")
		("jo" "/x/o")
		("ja" "/x/a")
		("j" "/x/")
		("j" "/x/")

		("gue" "/g/e")
		("gui" "/g/i")
		("gu" "/g/") ;this one is for adjectives. The spelling alternation is the same, but <> only occurs in adjectives
		("gu" "/g/")
		("go" "/g/o")
		("g" "/g/")
		("ga" "/g/a")
		("g" "/g/")

		("ge" "/gw/e")
		("gi" "/gw/i")
		("g" "/gw/")
		("g" "/gw/")
		("guo" "/gw/o")
		("gua" "/gw/a")
		("gu" "/gw/")
		("gu" "/gw/")
		
		("que" "/k/e")
		("qui" "/k/i")
		("qu" "/k/")
		("qu" "/k/")
		("co" "/k/o")
		("ca" "/k/a")
		("c" "/k/")
		("c" "/k/")

		("ce" "/Q/e")
		("ci" "/Q/i")
		("c" "/Q/")
		("c" "/Q/")
		("zo" "/Q/o")
		("za" "/Q/a")
		("z" "/Q/")
		("z" "/Q/")

	
		;spelling alterations for intesified forms of adjectives

		("bilsim" "blsim")

))